from enum import Enum


class SomePyQtEnum(Enum):

    one = 1
    two = 2


def cpp2py(etype, cpp):

    try:
        return etype(cpp)
    except ValueError:
        pass

    try:
        return etype._sip_unknowns[cpp]
    except KeyError:
        pass
    except AttributeError:
        etype._sip_unknowns = {}

    member = object.__new__(etype)
    member._name_ = str(cpp)
    member._value_ = cpp

    etype._sip_unknowns[cpp] = member

    return member


def py2cpp(py):

    return py.value


e1 = cpp2py(SomePyQtEnum, 1)
e2 = cpp2py(SomePyQtEnum, 2)
e3minus = cpp2py(SomePyQtEnum, -3)
e4 = cpp2py(SomePyQtEnum, 4)
e4a = cpp2py(SomePyQtEnum, 4)

print(e1)
print(e2)
print(e3minus)
print(e4)
print(e4a)
print(e4 is e4a)

print(py2cpp(e1))
print(py2cpp(e2))
print(py2cpp(e3minus))
print(py2cpp(e4))
